# STM32F072B-DISCO Discovery board

## Overview

The STM32F072 Discovery kit helps users to discover the full features of the STM32F0 Series and develop their applications. It is based on an STM32F072RBT6 microcontroller and includes an ST-LINK/V2 embedded debug tool interface, ST MEMS gyroscope, LEDs, push-buttons, linear touch sensor, touch keys, RF EEPROM connector and a USB Mini-B connector.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1690-discovery-kit-for-stm32f0-series-microcontrollers-with-stm32f072rb-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32F072RB microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32f072rb.html)
- [STM32F072B-DISCO board](https://www.st.com/en/evaluation-tools/32f072bdiscovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1690-discovery-kit-for-stm32f0-series-microcontrollers-with-stm32f072rb-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/32f072bdiscovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1076-f072b-c01_schematic.pdf)
